/* Header */

#include "includes.h"
#include "soap.h"

static char rcsid[] = "$Id: config.c,v 1.4 2002/09/20 03:32:46 crash Exp $";

Server *servers;
int servercount;

int read_settings(char *file) {
	FILE *fd;
	char buf[BUFSIZE], *parv[BUFSIZE];
	char *opt, *val;
	int parc;

	if ((fd = fopen(file, "r")) == NULL) {
		log("CONF => fopen() failed in read_settings()");
		return -1;
	}

	while(fgets(buf, BUFSIZE, fd)) {
		if (*buf == '#' || *buf == '\n' || *buf == '\r' || *buf == '\0' || !*buf)
			continue;

		strip(buf);

		parc = str2arrayq(parv, buf, ' ');
		opt = parv[1];
		val = parv[3];

		if (!strcasecmp(opt, "BanReason"))
			Setting.banmsg = strdup(val);

		if (!strcasecmp(opt, "Announce"))
			Setting.announce = atoi(val);

		if (!strcasecmp(opt, "Refferal"))
			Setting.refer = strdup(val);

		if (!strcasecmp(opt, "ScanNotice"))
			Setting.scanmsg = strdup(val);

		if (!strcasecmp(opt, "TellClients"))
			Setting.tellclient = atoi(val);

		if (!strcasecmp(opt, "BanType"))
			Setting.bantype = atoi(val);

		if (!strcasecmp(opt, "Blacklist"))
			me.bladdr = strdup(val);

		if (!strcasecmp(opt, "Timeout"))
			me.timeout = atoi(val);
	}

	fclose(fd);
}
int read_conf(char *file) {
	FILE *fd;
	char buf[BUFSIZE], *parv[BUFSIZE], c;
	Server *tmp;
	int parc, i;

	if ((fd = fopen(file, "r")) == NULL) {
		log("CONF=> fopen() failed in read_conf()");
		return -1;
	}

	while(fgets(buf, BUFSIZE, fd)) {
		strip(buf);
		parc = str2array(parv, buf, ':');
		c = **parv;
		switch(c) {
			case '\n':
			case '\r':
			case ' ':
			case '#':
			case '\0':
				break;
			case 'M':
				me.name = strdup(parv[1]);
				me.bindip = strdup(parv[2]);
				me.descr = strdup(parv[3]);
				me.bindport = atoi(parv[4]);
				me.bindfd = SetupListen(me.bindip, me.bindport, 0);
				log("STARTUP => Starting SOAP %s [%s:%d]\n", me.name, me.bindip, me.bindport);
				break;
			case 'A':
				me.admin1 = strdup(parv[1]);
				me.admin2 = strdup(parv[2]);
				me.admin3 = strdup(parv[3]);
				break;
			case 'X':
				me.respass = strdup(parv[1]);
				me.diepass = strdup(parv[2]);
				break;
			case 'C':
				if ((tmp = AddServer(parv[3])) != NULL) {
					tmp->ip = strdup(parv[1]);
					tmp->pass = strdup(parv[2]);
					tmp->port = atoi(parv[4]);
					tmp->state = SERV_DISCONNECTED;
					log("SERVER => Added Server %s [%s:%d] (%d)", tmp->name, tmp->ip, tmp->port, servercount);
				}
				break;
			case 'K':
			case 'k':
				break;
			case 'O':
			case 'o':
				break;
			default:
				printf("Unknown config option: %c\n", c);
				break;
		}
	}

	fclose(fd);
}
