/* Header */

#include "includes.h"
#include "soap.h"
#include "config.h"

static char rcsid[] = "$Id: dnsbl.c,v 1.3 2002/09/20 03:04:26 crash Exp $";

int CheckDNSBL(Scan *sc, Server *serv) {
	struct in_addr in;
	struct hostent *h;
	char *blip;
	size_t len;
	unsigned char a, b, c, d;
	

	if (!inet_aton(sc->ip, &in)) {
		log("DNSBL => Invalid ip %s", sc->ip);
		return 0;
	}

	len = 18+strlen(me.bladdr);

	blip = (char *)Malloc(len * sizeof(*blip));

	d = (unsigned char) (in.s_addr >> 24) & 0xFF;
	c = (unsigned char) (in.s_addr >> 16) & 0xFF;
	b = (unsigned char) (in.s_addr >> 8) & 0xFF;
	a = (unsigned char) in.s_addr & 0xFF;

	snprintf(blip, len+1, "%d.%d.%d.%d.%s.", d, c, b, a, me.bladdr);

	if (!(h = gethostbyname(blip))) {
		if (h_errno == NO_RECOVERY || h_errno == TRY_AGAIN) {
			/* Make sure its not thier local resolver */
			log("NON-FATAL => DNSBL lookup for %s Failed, Check your local resolver for problems.", sc->ip);
		}
		Free(blip);
		return 0;
	}
	Free(blip);

	kline_proxy(serv, sc, 1);

	return 1;
}
