/* Header */

#include <sys/errno.h>
#include "includes.h"
#include "soap.h"

static char rcsid[] = "$Id: misc.c,v 1.3 2002/09/20 03:05:53 crash Exp $";

static char *day[] = {
	"Sun",
	"Mon",
	"Tue",
	"Wed",
	"Thu",
	"Fri",
	"Sat"
};

static char *mon[] = {
	"Jan",
	"Feb",
	"Mar",
	"Apr",
	"May",
	"Jun",
	"Jul",
	"Aug",
	"Sep",
	"Oct",
	"Nov",
	"Dec"
};
	

void strip(char *line)
{
        char *c;
        
        if ((c = strchr(line, '\n')))   *c = '\0';
        if ((c = strchr(line, '\r')))   *c = '\0';
}

int get_dhm(char *buf, int time) {
	int mins = 1440, days = 1440, hours = 1440, secs = 1440, weeks = 1440;
/*
	mins = (time / 60); the minutes
	secs = (time - (mins * 60));  the seconds is the time - mins*60 

	hours = (mins / 60);  the hours 
	mins = (mins - (hours * 60));  recalculate the minutes 

	days  = (hours / 24);  the days 
	hours = (hours - (days * 24)); recalculate hours 

	weeks = (days / 7);  the weeks 
	days = (days - (weeks * 7));  recalc days 
*/
	sprintf(buf, "%dw %dd %dh %dm %ds", weeks, days, hours, mins, secs);
}

int str2array(char **pparv, char *ptr, char delim)
{
        int pparc = 0;
        
        while (*ptr) {
                pparv[pparc++] = ptr;
                ptr++;
                for (;;) {
			if (*ptr == delim) {
                        	*ptr = 0;
                                ptr++;
                                break;
                        }
                        if (!*ptr)
                                return pparc;
                        ptr++;
                }
        }
}

/* This function should put a string as such: Hello There "Dear Sir"
** into:
** parv[0] = "Hello\0"
** parv[1] = "There\0"
** parv[2] = "Dear Sir\0"
*/
int str2arrayq(char **pparv, char *ptr, char delim)
{
        int pparc = 0;

        while (*ptr) {
                if (*ptr == '"') {
                        ptr++;
                        pparv[pparc++] = ptr;
                        while (*ptr) {
                                if (*ptr == '"' || *ptr == '\n')
                                        *ptr = 0;
                                else
                                        ptr++;
                        }
                        return pparc;
                }
                else {
                        pparv[pparc++] = ptr;
                        ptr++;
                        for (;;) {
                                if (*ptr == delim) {
                                        *ptr = 0;
                                        ptr++;
                                        break;
                                }
                                if (!*ptr)
                                        return pparc;
                                ptr++;
                        }
                }
        }
}


int str2arrayc(char **pparv, char *ptr, char delim)
{
	int pparc = 0;
                    
	while (*ptr) {
		if (*ptr == ':') {
			ptr++;
			pparv[pparc++] = ptr;
			while (*ptr) {
				if (*ptr == '\n' || *ptr == '\r')
					*ptr = 0;
				else
					ptr++;
			}
			return pparc;
		}
		else {
			pparv[pparc++] = ptr;
			ptr++;
			for (;;) {
				if (*ptr == delim) {
					*ptr = 0;
					ptr++;
					break;
				}
				if (!*ptr)
					return pparc;
				ptr++;
			}
		}
	}
}

int debug(char *fmt,...) {
        va_list ap;
        char buf[BUFSIZE];
        int len;

        va_start(ap, fmt);
        vsnprintf(buf, BUFSIZE, fmt, ap);
        va_end(ap);

        strcat(buf, "\n");

        printf("%s", buf);
}

int open_log(char *file) {
	if ((me.logfd = fopen(file, "w+")) == NULL) {
		printf("FATAL => open_log() Failed for file %s; %s", file, strerror(errno));
		exit(-1);
	}

}

int log(char *fmt,...) {
        va_list ap;     
        char buf[BUFSIZE], buf2[BUFSIZE];
        int err;
	struct tm *lc;
	time_t ttime;
        
        va_start(ap, fmt);
        vsnprintf(buf, BUFSIZE, fmt, ap);
        va_end(ap);

	ttime = time(NULL);

	lc = localtime(&ttime);

	snprintf(buf2, BUFSIZE-1, "[%s %s %d %02d:%02d.%02d] %s\n", day[lc->tm_wday], mon[lc->tm_mon], lc->tm_mday, lc->tm_hour, lc->tm_min, lc->tm_sec, buf);
/*
	if (fprintf(me.logfd, "%s", buf2) == -1) {
		printf("LOG => Fatal log Failed; %s", strerror(errno));
		exit(-1);
	}
*/
	printf("%s", buf2);
}

void Free(void *ptr) {
	if (!ptr)
		return;

	free(ptr);

	if (!ptr) {
		log("NON-FATAL => Free() failed; %s", strerror(errno));
		return;
	}
}

void *Malloc(long size)
{                        
        void *buf;
 
        if (!size)
                size = 1;

        buf = malloc(size);

        if (!buf) {
		log("FATAL => Malloc() failed for %d bytes; %s", size, strerror(errno));
                exit(-1);
        }

        return buf;
}
