/* Header */

#include "includes.h"
#include "soap.h"

static char rcsid[] = "$Id: server.c,v 1.3 2002/09/20 03:06:53 crash Exp $";

Server *servers = 0;
int servercount;

int FD_USE = 0;

void add_serv_to_list(Server *newserv) {
	Server *ns;

	if (!servers) {
		newserv->next = 0;
		servers = newserv;
	}
	else {
		for (ns = servers; ns; ns = ns->next) {
			if (!ns->next) {
				newserv->next = 0;
				ns->next = newserv;
				break;
			}
		}
	}
	
}

Server *AddServer(char *name) {
	Server *new;

	new = (Server *)Malloc(sizeof(*new));

	if (!new) {
		log("FATAL => AddServer() Failed for %s, aborting", name);
		exit(-1);
	}

	new->name = strdup(name);

	new->scans = 0;
	new->scancount = 0;
	new->fails = 0;

	new->stats = (Stats *)Malloc(sizeof(*new->stats));
	new->stats->total = 0;
	new->stats->positive = 0;
	new->stats->negative = 0;
	new->stats->blist = 0;
	new->stats->timeouts = 0;
	new->stats->clients = 0;


	add_serv_to_list(new);

	servercount++;

	return new;
}

void del_serv_from_list(Server *del) {
	Server *ns;
	Server *last;

	if (del->sockfd > 0)
		close(del->sockfd);

	if (del->sockfd)
		FD_USE--;

	last = 0;

	for (ns = servers; ns; ns = ns->next) {
		if (ns == del) {
			if (last == 0)
				servers = ns->next;
			else
				last->next = ns->next;

			Free(ns->name);
			Free(ns);

			break;
		}
		last = ns;
	}
}

int DelServer(char *name) {
        Server *serv;

        if (!name)
                return -1;

	if ((serv = findserver(name)) == NULL)
		return -1;

        del_serv_from_list(serv);

	servercount--;

	return 0;
}

Server *findserver(char *name) {
        Server *serv;

	for (serv = servers; serv; serv = serv->next)
		if (!strcasecmp(serv->name, name))
			return serv;

        return NULL;
}
